/*
 
Copyright 2011 Bernardo Cuteri bernardoc91@hotmail.it  
 
This file is part of "Ascii Space Invaders".
 
"Ascii Space Invaders" is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
 
"Ascii Space Invaders" is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with "Ascii Space Invaders".  If not, see
<http://www.gnu.org/licenses/>.
 
*/


#include "Monster.h"
#include "Drop.h"
#include "Bullet.h"
#include <ncurses.h>
Bullet::Bullet()
: CoordX(0),CoordY(0),Attivita(false),Potenza(1),RedPower(0),BluePower(0)
{}
void Bullet::drawBullet()
{	
	if(CoordY>0 && !RedPower && !BluePower)
		mvprintw(CoordY,CoordX,".");
	else if(CoordY>0 && RedPower==1)
		mvprintw(CoordY,CoordX,"|");
	else if(CoordY>0 && BluePower==1)
		mvprintw(CoordY,CoordX,".");
	else if(CoordY>0 && BluePower==2)
		mvprintw(CoordY,CoordX,"|");
	else if(CoordY>0 && RedPower==2)
	{			
		attron(COLOR_PAIR(5));
		mvprintw(CoordY,CoordX,"|");
		attron(COLOR_PAIR(2));		
	}
	else if(CoordY>0 && RedPower==3)
	{			
		attron(COLOR_PAIR(7));
		mvprintw(CoordY,CoordX,"|");
		attron(COLOR_PAIR(2));		
	}
	else
		disattivazione();	
}
void Bullet::delBullet(Monster Mostri[],Drop Oggetti[],bool attacco,int dimMostri)
{
	if(attacco)
		if(CoordY<21)
		{
			mvprintw(CoordY,CoordX," ");	
			return;
		}	
	bool possibile=true;
	for(int i=0;i<50;i++)
		if(Oggetti[i].getAttivita() && Oggetti[i].getX()==CoordX && Oggetti[i].getY()==CoordY)
			possibile=false;
	if(possibile)
		for(int i=0;i<dimMostri;i++)
			if(Mostri[i].getAttivita() && Mostri[i].getX()==CoordX && Mostri[i].getY()==CoordY)
				possibile=false;
	if(possibile)
		if(CoordY<21)
			mvprintw(CoordY,CoordX," ");	
	if(!possibile)	
		for(int i=0;i<dimMostri;i++)
			if(Mostri[i].getAttivita() && Mostri[i].getX()==CoordX && Mostri[i].getY()==CoordY)
				Mostri[i].drawMonster();	
	
}
void Bullet::mvBullet()
{
	CoordY--;
}
bool Bullet::getAttivita()
{
	return Attivita;
}
void Bullet::attivazione(int start)
{
	CoordX=start;
	CoordY=21;
	Attivita=true;
}
void Bullet::disattivazione()
{
	if(RedPower)
		RedPower=0;
	if(BluePower)
		BluePower=0;
	Attivita=false;
}

int Bullet::getX()
{
	return CoordX;
}
int Bullet::getY()
{
	return CoordY;
}
int Bullet::getPotenza()
{
	return Potenza;
}
void Bullet::setRedPower(int value)
{
	if(value>=0 && value<4)	
		RedPower=value;
	else
		disattivazione();
}
int Bullet::getRedPower()
{
	return RedPower;
}
void Bullet::setBluePower(int value)
{
	if(value>=0 && value<3)	
		BluePower=value;
	else
		disattivazione();
}
int Bullet::getBluePower()
{
	return BluePower;
}



