/*
 
Copyright 2011 Bernardo Cuteri bernardoc91@hotmail.it  
 
This file is part of "Ascii Space Invaders".
 
"Ascii Space Invaders" is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
 
"Ascii Space Invaders" is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with "Ascii Space Invaders".  If not, see
<http://www.gnu.org/licenses/>.
 
*/

#include "Monster.h"
#include "Drop.h"
#include "Navicella.h"
#include <ncurses.h>
Drop::Drop()
: CoordX(0),CoordY(0),Attivita(false),Tipo(1)
{}
bool Drop::Effetto(Navicella & Nave,bool & GameOver)
{
	switch(Tipo)
	{
		case 1:		//Missile debole
			return Nave.moveHP(-1,GameOver);		
		case 2:		//Missile tratto nero
			return Nave.moveHP(-2,GameOver);		
		case 3:     //Missile tratto rosso
			return Nave.moveHP(-3,GameOver);			
		case 4:
			Nave.moveHP(1,GameOver);  //HP
			break;
		case 5:
			Nave.UpVita();  //Vita!
			break;
		case 6:
			Nave.riseRedPower();	//RedPower		
			break;
		case 7:
			Nave.riseBluePower();	//BluePower		
			break;
		case 8:
			Nave.setFreeze(170);	//Freeze	
			break;
		case 9:
			Nave.setDoubleDrop(2);	//DoubleDrop	
			break;
		
	}	
}
int Drop::drawDrop(Navicella & Nave,bool NaveMossa,bool & GameOver,bool & LifeLost)
{
	int temp=Nave.getX();
	int PosX[4]={temp,temp+1,temp-1,temp};
	int PosY[4]={22,22,22,21};	
	LifeLost=false;
	for(int i=0;i<4;i++)
		if(CoordY==PosY[i] && CoordX==PosX[i])
		{
			
			LifeLost=Effetto(Nave,GameOver);
			Nave.delNav(22);
						
			Attivita=false;
			if(Tipo==1 || Tipo==2 || Tipo==3)
			{
				Nave.drawNav(22,1);
				return Tipo;
			}
			if(Tipo==6 || Tipo==4 || Tipo==5 || Tipo==7 || Tipo==8 || Tipo==9)
			{
				Nave.drawNav(22,2);
				return Tipo;
			};
			
			
		}
	if(!NaveMossa)
	{
		switch(Tipo)
		{
			case 1:	 //Missile debole
				if(CoordY<40)
					mvprintw(CoordY,CoordX,".");
				else if(CoordY==40)
				{
					mvprintw(CoordY,CoordX,".");
					Attivita=false;
				}
				else
					Attivita=false;	
				break;
			case 2:	 //Missile forte
				if(CoordY<40)
					mvprintw(CoordY,CoordX,"|");
				else if(CoordY==40)
				{
					mvprintw(CoordY,CoordX,"|");
					Attivita=false;
				}
				else
					Attivita=false;	
				break;
			case 3:	 //Missile forte rosse			
				attron(COLOR_PAIR(5));
				if(CoordY<40)
					mvprintw(CoordY,CoordX,"|");
				else if(CoordY==40)
				{
					mvprintw(CoordY,CoordX,"|");
					Attivita=false;
				}
				else
					Attivita=false;	
				init_pair(2,COLOR_BLACK,COLOR_WHITE);
				attron(COLOR_PAIR(2));
				break;
			case 4:	 //HP
				attron(COLOR_PAIR(4));
				if(CoordY<40)
					mvprintw(CoordY,CoordX,"H");
				else if(CoordY==40)
				{
					mvprintw(CoordY,CoordX,"H");
					Attivita=false;
				}
				else
					Attivita=false;
				attron(COLOR_PAIR(2));
				break;	
			case 5:	 //Life
				attron(COLOR_PAIR(5));
				if(CoordY<40)
					mvprintw(CoordY,CoordX,"L");
				else if(CoordY==40)
				{
					mvprintw(CoordY,CoordX,"L");
					Attivita=false;
				}
				else
					Attivita=false;
				attron(COLOR_PAIR(2));
				break;	
			case 6:	 //RedPower
				attron(COLOR_PAIR(5));
				if(CoordY<40)
					mvprintw(CoordY,CoordX,"R");
				else if(CoordY==40)
				{
					mvprintw(CoordY,CoordX,"R");
					Attivita=false;
				}
				else
					Attivita=false;
				attron(COLOR_PAIR(2));
				break;	
			case 7:	 //RedPower
				
				attron(COLOR_PAIR(10));
				if(CoordY<40)
					mvprintw(CoordY,CoordX,"M");
				else if(CoordY==40)
				{
					mvprintw(CoordY,CoordX,"M");
					Attivita=false;
				}
				else
					Attivita=false;
				attron(COLOR_PAIR(2));
				break;	
			case 8:	 //Freeze
				attron(COLOR_PAIR(3));
				if(CoordY<40)
					mvprintw(CoordY,CoordX,"F");
				else if(CoordY==40)
				{
					mvprintw(CoordY,CoordX,"F");
					Attivita=false;
				}
				else
					Attivita=false;
				attron(COLOR_PAIR(2));
				break;	
			case 9:	 //DoubleDrop
				attron(COLOR_PAIR(12));
				if(CoordY<40)
					mvprintw(CoordY,CoordX,"D");
				else if(CoordY==40)
				{
					mvprintw(CoordY,CoordX,"D");
					Attivita=false;
				}
				else
					Attivita=false;
				attron(COLOR_PAIR(2));
				break;
			
		 }
	}
	return 0;
}
void Drop::delDrop(Monster Mostri[],int dimMostri)
{	
	mvprintw(CoordY,CoordX," ");
	for(int i=0;i<dimMostri;i++)	
		if(Mostri[i].getAttivita() && Mostri[i].getX()==CoordX && Mostri[i].getY()==CoordY)
			Mostri[i].drawMonster();
		
}

void Drop::mvDrop()
{
	CoordY++;
}
bool Drop::getAttivita()
{
	return Attivita;
}
void Drop ::attivazione(Monster start,int tp,bool PosizioniOccupateInMovimento [][80])
{
	if(start.getY()<21)
	{		
		CoordX=start.getX();
		CoordY=start.getY();
		Tipo=tp;
		Attivita=true;
		for(int i=CoordY;i<22;i++)
			PosizioniOccupateInMovimento[i][CoordX]=true;
	}
}
void Drop::disattivazione()
{
	Attivita=false;
}

int Drop::getX()
{
	return CoordX;
}
int Drop::getY()
{
	return CoordY;
}



