/*
 
Copyright 2011 Bernardo Cuteri bernardoc91@hotmail.it  
 
This file is part of "Ascii Space Invaders".
 
"Ascii Space Invaders" is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
 
"Ascii Space Invaders" is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with "Ascii Space Invaders".  If not, see
<http://www.gnu.org/licenses/>.
 
*/

#include "Bullet.h"
#include "Navicella.h"
#include "Monster.h"
#include "Drop.h"
#include "Documento.h"
#include <ncurses.h>
#include <string>
#include <cstring>
#include <iostream>
#include <time.h>
#include <stdlib.h>
#include <fstream>
#include <SFML/Audio.hpp>
 
using namespace std;

int Score;
const int DimY=24, DimX=80;
bool PosizioniOccupateInMovimento[24][80]={{0}};
const int dimMostri=160;
bool GameOver;
bool SoundOn=true;


sf::SoundBuffer SoundBuff1;
sf::SoundBuffer SoundBuff2;
sf::SoundBuffer SoundBuff3;
sf::SoundBuffer SoundBuff4;
sf::SoundBuffer SoundBuff5;
sf::SoundBuffer SoundBuff6;
sf::SoundBuffer SoundBuff7;
sf::SoundBuffer SoundBuff8;
sf::SoundBuffer SoundBuff9;
sf::Sound Sound1;
sf::Sound Sound2;
sf::Sound Sound3;
sf::Sound Sound4;
sf::Sound Sound5;
sf::Sound Sound6;
sf::Sound Sound7;
sf::Sound Sound8;
sf::Sound Sound9;



void livello1(Monster mostri[])
{
	int conta=0;	
	for(int i=20;i<DimX-20;i+=2)	
		for(int j=1;j<5;j++)		
			if(!(rand()%3))
			{
				if(rand()%5)
					mostri[conta].attivazione(j,i,1);
				else if(rand()%3)
					mostri[conta].attivazione(j,i,2);
				else
					mostri[conta].attivazione(j,i,3);
				mostri[conta].drawMonster();				
				conta++;
			}	
}
void livello2(Monster mostri[])
{
	int conta=0;
	for(int i=20;i<DimX-20;i+=2)	
		for(int j=1;j<5;j++)		
			if(!(rand()%3))
			{
				if(!(rand()%3))
					mostri[conta].attivazione(j,i,1);
				else if(rand()%3)
					mostri[conta].attivazione(j,i,2);
				else
					mostri[conta].attivazione(j,i,3);;
				mostri[conta].drawMonster();				
				conta++;
			}	
}
void livello3(Monster mostri[])
{
	int conta=0;
	for(int i=20;i<DimX-20;i+=2)	
		for(int j=1;j<5;j++)		
			if(rand()%2)
			{
				if(!(rand()%5))
					mostri[conta].attivazione(j,i,1);
				else if(rand()%3)
					mostri[conta].attivazione(j,i,2);
				else
					mostri[conta].attivazione(j,i,3);;
				mostri[conta].drawMonster();				
				conta++;
			}
}
void livello4(Monster mostri[])
{
	int conta=0;
	for(int i=20;i<DimX-20;i+=2)	
		for(int j=1;j<5;j++)		
			if(rand()%2)
			{
				if(!(rand()%5))
					mostri[conta].attivazione(j,i,1);
				else if(rand()%2)
					mostri[conta].attivazione(j,i,2);
				else
					mostri[conta].attivazione(j,i,3);;
				mostri[conta].drawMonster();				
				conta++;
			}	
}
void livello5(Monster mostri[])
{
	int conta=0;
	for(int i=20;i<DimX-20;i+=2)	
		for(int j=1;j<5;j++)		
			if(rand()%3)
			{
				if(!(rand()%10))
					mostri[conta].attivazione(j,i,1);
				else if(!(rand()%4))
					mostri[conta].attivazione(j,i,2);
				else
					mostri[conta].attivazione(j,i,3);;
				mostri[conta].drawMonster();				
				conta++;
			}	
}
void MuoviMissili(Bullet Missili[],Monster Mostri[],Drop Oggetti[])
{

	for(int i=0;i<20;i++)
	{
		if(Missili[i].getAttivita())
		{			
			Missili[i].delBullet(Mostri,Oggetti);
			Missili[i].mvBullet();			
			Missili[i].drawBullet();
		}			
	}	
}
void MuoviMostri(Monster Mostri[])
{
	bool mosso;	
	GameOver=false;
	for(int i=0;i<dimMostri;i++)	
	{
		mosso=false;
		if(Mostri[i].getAttivita())
		{			
			if(!(rand()%((Monster::NumeroDiMostriAttivi+10)/3)))
			{		
				int direzione=(rand()%9);  //0 alto,1 basso,2 destra,3 sinistra 
				bool possibile=false;
				if(Mostri[i].getMovimento()==-1)  //se il mostro NON si  già muovendo allora può muoversi
				{
					switch(direzione)
					{
						case 0:
							if(Mostri[i].getY()>1)
							{
								possibile=true;
								for(int j=0;j<dimMostri;j++)							
									if(Mostri[j].getAttivita() && Mostri[j].getX()==Mostri[i].getX() && Mostri[j].getY()==(Mostri[i].getY()-1) ||
																		PosizioniOccupateInMovimento[Mostri[i].getY()-1][Mostri[i].getX()])
										possibile=false;
							}
							if(possibile)
							{
								Mostri[i].delMonster();
								Mostri[i].setCoordY(Mostri[i].getY()-1);
								Mostri[i].drawMonster();
								mosso=true;
							}
							break;
						
						case 2:
							if(Mostri[i].getX()<DimX-22)
							{
								possibile=true;
								for(int j=0;j<dimMostri;j++)							
									if(Mostri[j].getAttivita() && Mostri[j].getX()==Mostri[i].getX()+2 && Mostri[j].getY()==(Mostri[i].getY()) ||
																PosizioniOccupateInMovimento[Mostri[i].getY()][Mostri[i].getX()+2])
										possibile=false;
							}
							if(possibile)
							{
								PosizioniOccupateInMovimento[Mostri[i].getY()][Mostri[i].getX()+2]=true;
								Mostri[i].delMonster();
								Mostri[i].setCoordX(Mostri[i].getX()+1);
								Mostri[i].drawMonster();
								Mostri[i].setMovimento(2);
								mosso=true;
								
							}
							break;
						case 3:
							if(Mostri[i].getX()>21)
							{
								possibile=true;
								for(int j=0;j<dimMostri;j++)							
									if(Mostri[j].getAttivita() && Mostri[j].getX()==Mostri[i].getX()-2 && Mostri[j].getY()==(Mostri[i].getY()) || 
																PosizioniOccupateInMovimento[Mostri[i].getY()][Mostri[i].getX()-2])
										possibile=false;
							}
							if(possibile)
							{
								PosizioniOccupateInMovimento[Mostri[i].getY()][Mostri[i].getX()-2]=true;
								Mostri[i].delMonster();
								Mostri[i].setCoordX(Mostri[i].getX()-1);
								Mostri[i].drawMonster();
								Mostri[i].setMovimento(3);
								mosso=true;
							}
							break;	
						case 1:							
						case 5:							
						case 6:								
						case 7:							
						case 8:
							if(Mostri[i].getY()<21)
							{
								possibile=true;
								for(int j=0;j<dimMostri;j++)							
									if(Mostri[j].getAttivita() && Mostri[j].getX()==Mostri[i].getX() && Mostri[j].getY()==(Mostri[i].getY()+1) || 
																		PosizioniOccupateInMovimento[Mostri[i].getY()+1][Mostri[i].getX()])
										possibile=false;
							}
							if(possibile)
							{
								Mostri[i].delMonster();
								Mostri[i].setCoordY(Mostri[i].getY()+1);
								Mostri[i].drawMonster();
								mosso=true;
							}
							break;	
					};
				}						
			}
			if(Mostri[i].getMovimento()==2 && !mosso)
			{
			
				Mostri[i].delMonster();
				Mostri[i].setCoordX(Mostri[i].getX()+1);
				Mostri[i].drawMonster();
				Mostri[i].setMovimento(-1);
				PosizioniOccupateInMovimento[Mostri[i].getY()][Mostri[i].getX()]=false;
			}
			else if(Mostri[i].getMovimento()==3 && !mosso)
			{
				
				Mostri[i].delMonster();
				Mostri[i].setCoordX(Mostri[i].getX()-1);
				Mostri[i].drawMonster();
				Mostri[i].setMovimento(-1);
				PosizioniOccupateInMovimento[Mostri[i].getY()][Mostri[i].getX()]=false;
			}			
		}	
	}
	for(int i=0;i<dimMostri;i++)
	{
		if((Mostri[i].getAttivita()) && ((Mostri[i].getY())==(DimY-3)))
		{				
			refresh();
			Mostri[i].drawMonster();
			refresh();			
			GameOver=true;
		}
	}
}
bool Attacchi(Bullet Missili[],Monster Mostri[],Drop Oggetti[],Navicella & Nave)
{
	bool dropAttivo;
	for(int i=0;i<20;i++)
		for(int j=0;j<dimMostri;j++)
		{
			if(Missili[i].getAttivita() && Mostri[j].getAttivita() && Missili[i].getY()==Mostri[j].getY() && Missili[i].getX()==Mostri[j].getX())
			{
				bool ExRP=false;
				bool ExBP=false;
				bool affondato=false;
				if(Missili[i].getRedPower())
				{
					ExRP=true;
					int RP=Missili[i].getRedPower();
					int NewRP=RP-(Mostri[j].getHP());
					affondato=(Mostri[j].danno(RP+1));
					Missili[i].setRedPower(NewRP);
				}
				else if(Missili[i].getBluePower())
				{
					ExBP=true;
					int BP=Missili[i].getBluePower();
					int NewBP=BP-(Mostri[j].getHP()+1);
					affondato=(Mostri[j].danno(BP));
					Missili[i].setBluePower(NewBP);
				}
				else
					affondato=(Mostri[j].danno(1));		
				if(affondato)
				{
					Score+=Mostri[j].getTipo()*10;
					if(Mostri[j].getMovimento()==2)
						PosizioniOccupateInMovimento[Mostri[j].getY()][Mostri[j].getX()+1]=false;
					else if(Mostri[j].getMovimento()==3)
						PosizioniOccupateInMovimento[Mostri[j].getY()][Mostri[j].getX()-1]=false;
					dropAttivo=false;
					if(!(rand()%(10/Nave.getDoubleDrop())))
					{
						int k=0;
						while(Oggetti[k].getAttivita()==true && k<50)
							k++;
						Oggetti[k].attivazione(Mostri[j],4,PosizioniOccupateInMovimento);
						dropAttivo=true;
					}
					if(!(rand()%(50/Nave.getDoubleDrop())) && !dropAttivo)
					{
						int k=0;
						while(Oggetti[k].getAttivita()==true && k<50)
							k++;
						Oggetti[k].attivazione(Mostri[j],5,PosizioniOccupateInMovimento);
						dropAttivo=true;
					}
					if(!(rand()%(12/Nave.getDoubleDrop())) && !dropAttivo)
					{
						int k=0;
						while(Oggetti[k].getAttivita()==true && k<50)
							k++;
						Oggetti[k].attivazione(Mostri[j],6,PosizioniOccupateInMovimento);
						dropAttivo=true;
					}
					if(!(rand()%(11/Nave.getDoubleDrop())) && !dropAttivo)  //11% per rendere il drop rate simile al RedPower (causa dropAttivo)
					{
						int k=0; 
						while(Oggetti[k].getAttivita()==true && k<50)
							k++;
						Oggetti[k].attivazione(Mostri[j],7,PosizioniOccupateInMovimento);
						dropAttivo=true;
					}
					if(!(rand()%(15/Nave.getDoubleDrop())) && !dropAttivo)
					{
						int k=0;
						while(Oggetti[k].getAttivita()==true && k<50)
							k++;
						Oggetti[k].attivazione(Mostri[j],8,PosizioniOccupateInMovimento);
						dropAttivo=true;
					}
					if(!(rand()%12) && !dropAttivo && Nave.getDoubleDrop()==1)
					{
						int k=0;
						while(Oggetti[k].getAttivita()==true && k<50)
							k++;
						Oggetti[k].attivazione(Mostri[j],9,PosizioniOccupateInMovimento);
						dropAttivo=true;
					}
				}
				if(!ExRP && !(ExBP))
				{
					Missili[i].delBullet(Mostri,Oggetti,true,dimMostri);				
					Missili[i].disattivazione();
				}
				if(!affondato)
				{
					Mostri[j].drawMonster();
					Sound4.Play();
				}
				else
				{
					Sound5.Play();
				}

			}		
		}
	for(int j=0;j<dimMostri;j++)	
		if(Mostri[j].getAttivita())
			return false;
	return true;
}
void stampaSoundSetup()
{
	mvprintw(0,62,"Press 'm' to turn");
	mvprintw(1,62,"the music ON/OFF");
	attron(COLOR_PAIR(3));
	mvprintw(0,69,"m");
	attron(COLOR_PAIR(2));
}
void AttacchiNemici(Drop Oggetti[],Monster Mostri[],Navicella & Nave)
{
	bool inferiore,possibile;	
	int corrX,corrY;
	for(int i=0;i<dimMostri;i++)
	{		
		if(Mostri[i].getAttivita())
		{
			inferiore=true;
			corrX=Mostri[i].getX();
			corrY=Mostri[i].getY();	
			for(int j=0;j<dimMostri;j++)
				if(Mostri[j].getAttivita() && Mostri[j].getX()==corrX && Mostri[j].getY()>corrY)
					inferiore=false;			
			if(inferiore && rand()%200==0)
			{
				possibile=true;
				int k=0;
				while(Oggetti[k].getAttivita()==true && k<50)
					k++;
				for(int l=0;l<50;l++)		
					if(Oggetti[l].getAttivita() && Oggetti[k].getX()==Oggetti[l].getX() && Oggetti[k].getY()==Oggetti[l].getY())
						possibile=false;
				if(possibile)
					 Oggetti[k].attivazione(Mostri[i],Mostri[i].getTipo(),PosizioniOccupateInMovimento);
				//Oggetti[k].drawDrop(Nave);
			}
		}
	}
}
void mvNave(int Direzione,Navicella & Nave,Drop Oggetti[],int & Colpita)
{
	if(Direzione==-1)
	{
		Nave.delNav(DimY-2);
		Nave--;
		Nave.drawNav(DimY-2);
	}
	else
	{
		Nave.delNav(DimY-2);
		Nave++;
		Nave.drawNav(DimY-2);
	}
	int ColpitaTemp;
	bool LifeLost=false;
	for(int i=0;i<40;i++)
	{		
		if(Oggetti[i].getAttivita())
		{
			ColpitaTemp=Oggetti[i].drawDrop(Nave,true,GameOver,LifeLost);
			if(ColpitaTemp!=0)
				Colpita=ColpitaTemp;

			if((ColpitaTemp==1 || ColpitaTemp==2 || ColpitaTemp==3) && !LifeLost)				
				Sound1.Play();

			else if(ColpitaTemp==4 || ColpitaTemp==5 || ColpitaTemp==6 || ColpitaTemp==7 || ColpitaTemp==9)
				Sound2.Play();
			else if(ColpitaTemp==8)
				Sound3.Play();
			if(LifeLost)
				Sound7.Play();
		
		}	
	}
	
}
 
void MuoviDrops(Drop Oggetti[],Navicella & Nave,int & Colpita,Monster Mostri[])
{
	bool LifeLost=false;
	int ColpitaTemp;
	for(int i=0;i<40;i++)
		if(Oggetti[i].getAttivita())
		{						
			Oggetti[i].delDrop(Mostri,dimMostri);			
			Oggetti[i].mvDrop();
			ColpitaTemp=Oggetti[i].drawDrop(Nave,false,GameOver,LifeLost);
			if(ColpitaTemp!=0)
			{
				Colpita=ColpitaTemp;
			}			
			if((ColpitaTemp==1 || ColpitaTemp==2 || ColpitaTemp==3) && !LifeLost)				
				Sound1.Play();

			else if(ColpitaTemp==4 || ColpitaTemp==5 || ColpitaTemp==6 || ColpitaTemp==7 || ColpitaTemp==9)
				Sound2.Play();
			else if(ColpitaTemp==8)
				Sound3.Play();
			if(LifeLost)
				Sound7.Play();
			PosizioniOccupateInMovimento[Oggetti[i].getY()-1][Oggetti[i].getX()]=false;
			if(Oggetti[i].getY()==23)
			{
				Oggetti[i].disattivazione();
				Oggetti[i].delDrop(Mostri,dimMostri);
			}
		}		
}
void Classifica()
{
	for(int i=0;i<DimX;i++)
		for(int j=0;j<DimY;j++)
			mvprintw(j,i," ");
	for(int i=0;i<DimY;i++)			
		mvprintw(i,18,"|");
	for(int i=0;i<DimY;i++)			
			mvprintw(i,61,"|");
	ifstream fin;
	char buffer[20];
	fin.open("classifica.dat");
	if(!fin.is_open())
		return;
	for(int i=0;i<10;i++)
	{
		fin.ignore();
		fin.getline(buffer,19,';');
		switch(i/2)
		{
			case 0:
				attron(COLOR_PAIR(5));
				break;
			case 1:
				attron(COLOR_PAIR(7));
				break;
			case 2:
				attron(COLOR_PAIR(6));
				break;
			case 3:
				attron(COLOR_PAIR(3));
				break;
			case 4:
				attron(COLOR_PAIR(10));
				break;
		}
		if(i%2)
			mvprintw(i*2+1,38,buffer);
		else		
			mvprintw((i+1)*2+1,28,buffer);	
				
		
	}
	attron(COLOR_PAIR(2));
	mvprintw(22,28,"press any key to continue...");
	refresh();
	int exitKey=0;	
	do
	{
		exitKey=getch();		
	
	}while(exitKey==-1);
	
	fin.close();
	
	

}
void aggiornaClassifica(char actualScore[])
{
	
	ofstream outfile;
	ifstream infile;	
	char giocatori[5][15];
	char scores[5][6];
	int num=0;		
	infile.open("classifica.dat");
	if(!infile.is_open())
		return;		
	for(int i=0;i<10;i++)
	{
		infile.ignore();
		if(i%2)
			infile.getline(giocatori[i/2],14,';');
		else
			infile.getline(scores[i/2],5,';');
	}
	infile.close();
	bool trovato=false;
	int pos;
	char giocatore[15];
	for(int i=0;i<5 && !trovato;i++)
	{
		if(strlen(actualScore)>strlen(scores[i]) || strlen(actualScore)==strlen(scores[i]) && strcmp(actualScore,scores[i])>0)
		{
			for(int k=0;k<DimX;k++)
				for(int j=0;j<DimY;j++)
					mvprintw(j,k," ");
			pos=i;
			int tasto=-1,contachar=0;
			
			giocatore[0]='\0';			
			trovato=true;
			attron(COLOR_PAIR(5));
			mvprintw(10,30,"High score!");
			attron(COLOR_PAIR(2));
			mvprintw(12,28,"Inserire il nome:");
			attron(COLOR_PAIR(10));
			curs_set(1);			
			move(14,28);			
			do
			{
				if(tasto==10)
				{
					attron(COLOR_PAIR(5));
					mvprintw(16,27,"Almeno tre caratteri");
					move(14,28+contachar);
					refresh();					
					attron(COLOR_PAIR(10));
				}
				tasto=getch();
				if((tasto>='a' && tasto<='z' || tasto>='A' && tasto<='Z' || tasto>='0' && tasto<='9' || tasto==' ' && contachar>0) && contachar<14)
				{
					giocatore[contachar]=tasto;
					giocatore[++contachar]='\0';
					mvprintw(14,28,giocatore);
				}
				else if(tasto==263 && contachar>0)
				{
					mvprintw(14,28,"               ");
					giocatore[--contachar]='\0';
					mvprintw(14,28,giocatore);
				}
			}while(tasto!=10 || contachar<3);
			attron(COLOR_PAIR(2));
			curs_set(0);		
		}
	}
	if(trovato)
	{
		for(int i=4;i>pos;i--)
		{
			strcpy(giocatori[i],giocatori[i-1]);
			strcpy(scores[i],scores[i-1]);
		}
		strcpy(giocatori[pos],giocatore);
		strcpy(scores[pos],actualScore);
		outfile.open("classifica.dat");
		if(!outfile.is_open())
			return;
		outfile<<" ";
		for(int i=0;i<10;i++)
		{
			if(i%2)
				outfile<<(giocatori[i/2]);
			else			
				outfile<<(scores[i/2]);
			outfile<<"; ";
		}		
		outfile.close();
		Classifica();
	}
}
void Sound_ON_OFF()
{
	if(SoundOn)
	{
		Sound1.SetVolume(0);
		Sound2.SetVolume(0);
		Sound3.SetVolume(0);
		Sound4.SetVolume(0);
		Sound5.SetVolume(0);
		Sound6.SetVolume(0);
		Sound7.SetVolume(0);
		Sound8.SetVolume(0);
		Sound9.SetVolume(0);
		SoundOn=false;
	}
	else 
	{
		Sound1.SetVolume(50);
		Sound2.SetVolume(100);
		Sound3.SetVolume(25);
		Sound4.SetVolume(100);
		Sound5.SetVolume(100);
		Sound6.SetVolume(60);
		Sound7.SetVolume(30);
		Sound8.SetVolume(100);
		Sound9.SetVolume(100);
		SoundOn=true;
	}
	



}
void submain(Navicella & Nave)
{
	for(int i=0;i<DimX;i++)
		for(int j=0;j<DimY;j++)
			mvprintw(j,i," ");	
	for(int i=0;i<DimY;i++)			
			mvprintw(i,18,"|");
	for(int i=0;i<DimY;i++)			
			mvprintw(i,61,"|");

	stampaSoundSetup();
	int tasto=0;
	Nave.reset();
	GameOver=false;
	Score=0;		
	Nave.drawNav(DimY-2);
	refresh();
	Bullet Missili[20];	
	Drop Oggetti[50];
	Monster Mostri[dimMostri];
	int contaLivelli=1;
	bool vittoria=false;
	bool uscire=false;			
	int Colpita=0;
	int Colpita2;
	int ContatoreGiallo=0;
	int MissileNonDisponibile=0;
	bool sx=false;
	int ContatoreModulo=0;
	char ScoreBuffer[7];
	attron(COLOR_PAIR(5));			
	mvprintw(21,2,"LIFES POINTS:");
	attron(COLOR_PAIR(15));
	for(int i=0;i<9;i+=3)
	{
		mvprintw(22,2+i," ");
		mvprintw(22,3+i," ");			
	}
	attron(COLOR_PAIR(4));	
	mvprintw(19,2,"HEALTH POINTS:");
	attron(COLOR_PAIR(17));
	for(int i=0;i<12;i+=4)
	{
		mvprintw(20,2+i," ");
		mvprintw(20,3+i," ");
		mvprintw(20,4+i," ");		
	}
	attron(COLOR_PAIR(3));
	mvprintw(4,4,"Score: ");
	attron(COLOR_PAIR(2));
	sprintf(ScoreBuffer,"%d",Score);	
	mvprintw(4,11,ScoreBuffer);
	do
	{				
		for(int i=0;i<20;i++)
			if(Missili[i].getAttivita())
			{
				Missili[i].disattivazione();
				Missili[i].delBullet(Mostri,Oggetti,true,dimMostri);
			}
		for(int i=0;i<40;i++)
			if(Oggetti[i].getAttivita())
			{
				Oggetti[i].disattivazione();
				Oggetti[i].delDrop(Mostri,dimMostri);
			}
		switch(contaLivelli)
		{	
			case 1:				
				livello1(Mostri);
				attron(COLOR_PAIR(10));
				break;
			case 2:
				livello2(Mostri);
				attron(COLOR_PAIR(3));
				break;		
			case 3:
				livello3(Mostri);
				attron(COLOR_PAIR(6));
				break;	
			case 4:
				livello4(Mostri);
				attron(COLOR_PAIR(7));
				break;	
			case 5:
				livello5(Mostri);
				attron(COLOR_PAIR(5));
				break;	
		}
		
		char corrLivello[3];
		sprintf(corrLivello,"%d",contaLivelli);						
		mvprintw(15,1,"Level ");
		printw(corrLivello);
		printw(" up to 5");
		attron(COLOR_PAIR(2));
		refresh();	
		int ContaCicliUnit=0;	
		int ContaCicliDieci=0;
		do    // Ciclo principale del gioco
		{
			if(ContaCicliUnit<10)	
				ContaCicliUnit++;
			else
			{
				ContaCicliDieci++;	
				ContaCicliUnit=0;
			}					
			if(ContatoreGiallo!=0)   //la navicella si illumina per qualche frame se colpita o se ottiene un bonus
			{
				Nave.delNav(DimY-2);
				Nave.drawNav(DimY-2);
				ContatoreGiallo--;					
			}	
			if(MissileNonDisponibile!=0)
				MissileNonDisponibile--;	
			ContatoreModulo=(ContatoreModulo+1)%10;
			usleep(20000);							//usleep principale
			if(!(ContatoreModulo%2))			//i missili della navicella.. ogni 40 ms circa si muovono
				MuoviMissili(Missili,Mostri,Oggetti);				
			vittoria=Attacchi(Missili,Mostri,Oggetti,Nave);
			if(!ContatoreModulo && !Nave.getFreeze())
				MuoviMostri(Mostri);	
			if(!vittoria && !Nave.getFreeze())
			{
				AttacchiNemici(Oggetti,Mostri,Nave);
			}
			else if(Nave.getFreeze())
				Nave.setFreeze(Nave.getFreeze()-1);
			if(!(ContatoreModulo%5))					//i drops si muovono un frame ogni 5
				MuoviDrops(Oggetti,Nave,Colpita,Mostri);			
			tasto=getch();		//lettura tasti in fase di gioco
			if(tasto)
			{
				switch(tasto)
				{
					case (KEY_LEFT):
						if(Nave.getX()-20 > 0)
						{
							mvNave(-1,Nave,Oggetti,Colpita);
						
						}
						break;		
					case (KEY_RIGHT):
						if(Nave.getX()+21 < DimX)
						{
							mvNave(1,Nave,Oggetti,Colpita);								
						}
						break;
					case (' '):
						if(!MissileNonDisponibile)
						{															
							bool trovato=false;
							for(int i=0;i<20 && !trovato;i++)
								if(!Missili[i].getAttivita())
								{
									Missili[i].attivazione(Nave.getX());									
									
									if(Nave.getRedPower())
										Missili[i].setRedPower(Nave.getRedPower());										
									trovato=true;
									MissileNonDisponibile=14-(Nave.getRedPower()*3/2);	// il missile non sarà più disponibile per i 				
								}														//successivi "MissileNonDisp." frames
							if(Nave.getBluePower()==3)									//con il RedPower attivo i missili si ricaricano
							{															//più rapidamente
								int trovato2=0;								
								for(int i=0;i<20 && trovato2!=2 ;i++)
									if(!(Missili[i].getAttivita()) && trovato2!=2)
									{
										if(trovato2)		
										{							
											Missili[i].attivazione(Nave.getX()-1);
											Missili[i].setBluePower(2);						//parte dedicata al Multi-Shot
										}											
										else									
										{
											Missili[i].attivazione(Nave.getX()+1);
											Missili[i].setBluePower(2);
										}					
										trovato2++;
									}									
							}
							else if(Nave.getBluePower()==2)
							{
								int trovato2=0;								
								for(int i=0;i<20 && trovato2!=2 ;i++)
									if(!(Missili[i].getAttivita()) && trovato2!=2)
									{
										if(trovato2)		
										{							
											Missili[i].attivazione(Nave.getX()-1);
											Missili[i].setBluePower(1);	
										}											
										else
										{
											Missili[i].attivazione(Nave.getX()+1);
											Missili[i].setBluePower(1);
										}					
										trovato2++;
									}									
							}
							else if(Nave.getBluePower())
							{
								int trovato2=0;								
								for(int i=0;i<20 && trovato2!=2 ;i++)
									if(!(Missili[i].getAttivita()) && trovato2!=2)
									{
										if(trovato2==0)
										{											
											if(sx)
											{
												Missili[i].attivazione(Nave.getX()-1);
												Missili[i].setBluePower(Nave.getBluePower());													
											}
										}
										else if(trovato2==1)
										{												
											if(!sx)
											{
												Missili[i].attivazione(Nave.getX()+1);	
												Missili[i].setBluePower(Nave.getBluePower());													
											}
										}									
										trovato2++;
									}
								if(sx)
									sx=false;
								else
									sx=true;
							}
						
						}
						break;
					case('p'):
					case('P'):
						mvprintw(2,1,"PAUSE");
						refresh();
						int Pause;
						
						Pause=0;							 
						do
						{
							Pause=getch();		
						}while(Pause!='p' && Pause!= 'P');						
						mvprintw(2,1,"     ");
						refresh();							
						break;						
					case(27):
						mvprintw(2,1,"USCIRE? [s]/[n]");
						refresh();
						int exit;						
						exit=0;							 
						do
						{
							exit=getch();		
						}while(exit!='s' && exit!= 'n' && exit!='S' && exit!= 'N');		
						if(exit=='n' || exit=='N')				
							mvprintw(2,1,"               ");  
						else
							uscire=true;
						refresh();							
						break;	
					case('m'):
					case('M'):
						Sound_ON_OFF();
						break;
				}								
			}
			if(Colpita)  //colpita è un intero che indica che tipo di oggetto ci ha colpiti
			{
				Colpita2=Colpita;
				Colpita=0;
				ContatoreGiallo=10;
			}
			if(ContatoreGiallo)
			{
				Nave.delNav(DimY-2);
				Nave.drawNav(DimY-2,Colpita2);	
			}
			sprintf(ScoreBuffer,"%d",Score);
			mvprintw (4,11,ScoreBuffer);
			refresh();				
		}while(!GameOver && !vittoria && !uscire);
		contaLivelli++;
		if(!GameOver && contaLivelli<6 && !uscire)
		{	
			
			Nave.setFreeze(0);   //eliminiamo tutti i power-up e gli effetti 
			Nave.closeBluePower();
			Nave.closeRedPower();
			Nave.setDoubleDrop(1);
			for(int i=30;i<50;i++)
				for(int j=9;j<12;j++)
					mvprintw(i,j," ");
			stampaSoundSetup();
			int exit=-1,colore=5;
			Sound8.Play();
			do
			{
				if(colore==10)
				{
					attron(COLOR_PAIR(colore));
					colore=5;
				}
				else if(colore==7)						//Effetto colore cangiante
				{
					attron(COLOR_PAIR(colore));
					colore=10;
				}
				else
					attron(COLOR_PAIR(colore++));
				mvprintw(10,35,"Next level");	
				mvprintw(12,28,"Press any key to continue...");					
				refresh();
				sleep(1);			
				exit=getch();
			}while(exit==-1);				
	               
			attron(COLOR_PAIR(2));
			for(int i=20;i<DimX;i++)
				for(int j=0;j<DimY;j++)
					mvprintw(j,i," ");			
			for(int i=0;i<DimY;i++)			
				mvprintw(i,61,"|");		
			stampaSoundSetup();
			Nave.drawNav(DimY-2);	
			tasto=-1;  
		}	
		if(!GameOver && contaLivelli<7 && !uscire)
		{
			int TimeBonus=0;
			switch(contaLivelli)
			{
				case 2:   //riguardante il livello 1 
					if(ContaCicliDieci<200)   // Numero medio maggiorato di ContaCicliDieci dopo il primo livello (tempo che un principiante impiega
						TimeBonus=((200-ContaCicliDieci)*10);				//per completare il livello)
					break;
				case 3:   
					if(ContaCicliDieci<240)   
						TimeBonus=((240-ContaCicliDieci)*10);
					break;
				case 4:   
					if(ContaCicliDieci<255)   
						TimeBonus=((255-ContaCicliDieci)*10);
					break;
				case 5:   
					if(ContaCicliDieci<290)   
						TimeBonus=((290-ContaCicliDieci)*10);
					break;
				case 6:   
					if(ContaCicliDieci<370)   
						TimeBonus=((370-ContaCicliDieci)*10);
					break;
			}
			char TimeBuffer[5];
			sprintf(TimeBuffer,"%d",TimeBonus);
			attron(COLOR_PAIR(5));
			mvprintw (7,2,"TimeBonus: ");
			attron(COLOR_PAIR(2));
			sleep(1);
			mvprintw (7,13,TimeBuffer);
			refresh();
			sleep(1);
			while(TimeBonus>0)   //effetto "numeri che scorrono rapidamente"
			{
				Score+=10;
				TimeBonus-=10;
				sprintf(ScoreBuffer,"%d",Score);
				sprintf(TimeBuffer,"%d",TimeBonus);
				mvprintw (7,13,"    ");
				mvprintw (4,11,"     ");
				mvprintw (7,13,TimeBuffer);
				mvprintw (4,11,ScoreBuffer);
				usleep(40000);
				refresh();
			}
			sleep(1);			
			sprintf(ScoreBuffer,"%d",Score);
			mvprintw (4,11,ScoreBuffer);
			mvprintw (7,2,"               ");
			refresh();
			sleep(1);
			
		}		
	}while(!GameOver && contaLivelli<6 && !uscire);
	if(!GameOver && !uscire)
	{
		attron(COLOR_PAIR(13));
		for(int i=0;i<42;i++)
			for(int j=0;j<5;j++)
				mvprintw(5+j,19+i," ");	
		Sound8.Play();
		mvprintw(7,20,"Congratulations, you completed the game!");
		attron(COLOR_PAIR(2));
		refresh();
		sleep(2);	
		int exitk=-1;	
		do
		{	
			exitk=getch();
		}while(exitk==-1);
		aggiornaClassifica(ScoreBuffer);		
	}			
	if(GameOver)
	{
		int posizioni[100];
		int contatore=0;		
		for(int i=0;i<dimMostri;i++)
		{			
			if((Mostri[i].getAttivita()) && (Mostri[i].getY()==DimY-3))	
			{				
				posizioni[contatore]=i;
				contatore++;					
			}
		}
		Sound6.Play();
		for(int i=0;i<4;i++)
		{
			if(i%2==0)
			{
				for(int j=0;j<contatore;j++)
				{			
					sleep(1);					
					Mostri[posizioni[j]].GameOver(8);								
				}
			}				
			else
			{					
				for(int j=0;j<contatore;j++)
				{			
					sleep(1);					
					Mostri[posizioni[j]].GameOver(9);								
				}
			}
			refresh();						
		}	
		attron(COLOR_PAIR(14));
		for(int i=0;i<42;i++)
			for(int j=0;j<5;j++)
				mvprintw(5+j,19+i," ");	
		mvprintw(7,25,"Game Over, monsters defeated you.");
		attron(COLOR_PAIR(2));
		refresh();
		sleep(2);
		int exitk=-1;	
		do
		{	
			exitk=getch();
		}while(exitk==-1);
		aggiornaClassifica(ScoreBuffer);		
		
	}

}
void Istruzioni()
{
	for(int i=0;i<DimX;i++)
		for(int j=0;j<DimY;j++)
			mvprintw(j,i," ");
	string Istruzioni="Instructions.txt";
	Documento doc(Istruzioni);
	doc.drawIt();
	attron(COLOR_PAIR(10));
	mvprintw(5,32,"M");
	attron(COLOR_PAIR(5));
	mvprintw(6,65,"R");
	attron(COLOR_PAIR(3));
	mvprintw(9,36,"F");
	attron(COLOR_PAIR(12));
	mvprintw(10,59,"D");
	attron(COLOR_PAIR(4));
	mvprintw(12,13,"HP");
	attron(COLOR_PAIR(5));
	mvprintw(13,20,"L");
	attron(COLOR_PAIR(2));
	refresh();
	
	int exit=-1;
	do
	{
		exit=getch();
	}while(exit==-1);

}
void stampaTitolo()
{
	attron(COLOR_PAIR(2));
	for(int i=0;i<DimX;i++)
		for(int j=0;j<DimY;j++)
			mvprintw(j,i," ");
	attron(COLOR_PAIR(12));
	mvprintw(1,1,"                                                          ##                   ");
	attron(COLOR_PAIR(5));
	mvprintw(2,1," ####                          ####                       ##                   ");
	attron(COLOR_PAIR(7));
	mvprintw(3,1,"##    # ##   ###   ###  ###     ##  # ##  ##  ##  ###   ####  ###  ## ##  #### ");
	attron(COLOR_PAIR(6));
	mvprintw(4,1,"###   ## ##    ## ##   ## ##    ##  ## ## ##  ##    ## ## ## ## ## ##### ##    ");
	attron(COLOR_PAIR(3));
	mvprintw(5,1," ###  ## ##  #### ##   ## ##    ##  ## ##  ## #   #### ## ## ## ## ##    ####  ");		//SPACE INVADERS in ascii art
	attron(COLOR_PAIR(10));
	mvprintw(6,1,"  ### ## ## ## ## ##   #####    ##  ## ##  ####  ## ## ## ## ##### ##     #### ");
	attron(COLOR_PAIR(12));
	mvprintw(7,1,"   ## ## ## ## ## ##   ##       ##  ## ##   ##   ## ## ## ## ##    ##       ## ");
	attron(COLOR_PAIR(5));
	mvprintw(8,1,"####  ####   ## #  ###  ####   #### ## ##   ##    ## #  ## #  #### ##    ####  ");
	attron(COLOR_PAIR(7));
	mvprintw(9,1,"      ##                                                                       ");
	attron(COLOR_PAIR(6));
	mvprintw(10,1,"      ##                                                                       ");
	attron(COLOR_PAIR(11));
	mvprintw(13,27,"Start Game");
	attron(COLOR_PAIR(2));
	mvprintw(15,30,"High Scores");
	mvprintw(17,33,"Instructions");
	mvprintw(19,36,"Exit");	
}
int main() 
{	
	srand(time(0));
	initscr();	
	if(COLS<DimX || LINES<DimY)
	{
		mvprintw(1,1,"Finestra troppo piccola, aumentare le dimensioni della stessa per giocare");
		refresh();		
	}
	else
	{
		start_color();
		init_pair(3,COLOR_CYAN,COLOR_WHITE);   //Raccolta delle coppie di colori da utilizzare
		init_pair(5,COLOR_RED,COLOR_WHITE);
		init_pair(2,COLOR_BLACK,COLOR_WHITE);
		init_pair(7,COLOR_YELLOW,COLOR_WHITE);
		init_pair(10,COLOR_BLUE,COLOR_WHITE);		
		init_pair(6,COLOR_GREEN,COLOR_WHITE);
		init_pair(4,COLOR_GREEN,COLOR_WHITE);
		init_pair(8,COLOR_RED,COLOR_YELLOW);
		init_pair(9,COLOR_BLACK,COLOR_YELLOW);
		init_pair(11,COLOR_WHITE,COLOR_BLUE);
		init_pair(12,COLOR_MAGENTA,COLOR_WHITE);
		init_pair(13,COLOR_RED,COLOR_GREEN);
		init_pair(14,COLOR_YELLOW,COLOR_BLACK);
		init_pair(15,COLOR_WHITE,COLOR_RED);
		init_pair(16,COLOR_WHITE,COLOR_BLUE);
		init_pair(17,COLOR_WHITE,COLOR_GREEN);
		attron(COLOR_PAIR(2));											
		keypad(stdscr,1);
		noecho();						//funzione di ncurses che nasconde l'input da tastiera evitando che venga stampata su schermo
		curs_set(0);				//il cursore diventa invisibile grazie  a questa chiamata a curs_set()
		cbreak();					
		int tasto;				
		timeout(0);
		int scelta=0;
		Navicella Nave;  //creiamo la nave che useremo per ogni partita
		

		SoundBuff1.LoadFromFile("Sounds/Attacked.wav");
		SoundBuff2.LoadFromFile("Sounds/PowerUp.wav");
		SoundBuff3.LoadFromFile("Sounds/DrainMagic.ogg");
		SoundBuff4.LoadFromFile("Sounds/Colpito.wav");
		SoundBuff5.LoadFromFile("Sounds/Affondato.wav");
		SoundBuff6.LoadFromFile("Sounds/GameOver.wav");
		SoundBuff7.LoadFromFile("Sounds/LifeLost.ogg");
		SoundBuff8.LoadFromFile("Sounds/NextLevel.wav");
		SoundBuff9.LoadFromFile("Sounds/Start.wav");
		Sound1.SetBuffer(SoundBuff1);
		Sound1.SetVolume(50);
		Sound2.SetBuffer(SoundBuff2);
		Sound3.SetBuffer(SoundBuff3);
		Sound3.SetVolume(25);
		Sound4.SetBuffer(SoundBuff4);	
		Sound5.SetBuffer(SoundBuff5);
		Sound6.SetBuffer(SoundBuff6);
		Sound7.SetBuffer(SoundBuff7);
		Sound8.SetBuffer(SoundBuff8);
		Sound9.SetBuffer(SoundBuff9);
		Sound6.SetVolume(60);
		Sound7.SetVolume(30);
		while(scelta!=3)
		{
			tasto=-1;
			stampaTitolo();
			do
			{							
				tasto=getch();		
				if(tasto)
				{
					switch(tasto)
					{
						case KEY_DOWN:
							scelta=(scelta+1)%4;  //menù a scorrimento tramite tastiera 
							Sound4.Play();
							break;
					
						case KEY_UP:						
							scelta=(scelta-1)%4;
							if(scelta<0)
								scelta+=4;
							Sound4.Play();
							break;
					}
					switch (scelta)
					{
						case 0:
							attron(COLOR_PAIR(11));
							mvprintw(13,27,"Start Game");
							attron(COLOR_PAIR(2));
							mvprintw(15,30,"High Scores");
							mvprintw(17,33,"Instructions");
							mvprintw(19,36,"Exit");
							break;					
						case 1:						
							mvprintw(13,27,"Start Game");
							attron(COLOR_PAIR(11));
							mvprintw(15,30,"High Scores");
							attron(COLOR_PAIR(2));
							mvprintw(17,33,"Instructions");
							mvprintw(19,36,"Exit");
							break;
						case 2:
							mvprintw(13,27,"Start Game");						
							mvprintw(15,30,"High Scores");
							attron(COLOR_PAIR(11));	
							mvprintw(17,33,"Instructions");
							attron(COLOR_PAIR(2));
							mvprintw(19,36,"Exit");
							break;
						case 3:
							mvprintw(13,27,"Start Game");						
							mvprintw(15,30,"High Scores");						
							mvprintw(17,33,"Instructions");
							attron(COLOR_PAIR(11));
							mvprintw(19,36,"Exit");
							attron(COLOR_PAIR(2));
							break;				
					}				
				}				
			
			}while(tasto!=' ' && tasto!=10);
			
			if(scelta==0)
			{
				attron(COLOR_PAIR(17));
				mvprintw(13,27,"Start Game");
				attron(COLOR_PAIR(2));
				refresh();
				Sound9.Play();
				usleep(200000);  //in questo intervallo di tempo voce selezionata si illumina di verde
				submain(Nave); //Funzione "gioca"
			}
			else if(scelta==1)
			{
				attron(COLOR_PAIR(17));
				mvprintw(15,30,"High Scores");
				attron(COLOR_PAIR(2));	
				refresh();
				Sound5.Play();
				usleep(200000);	
				Classifica();	
			}
			else if(scelta==2)	
			{
				attron(COLOR_PAIR(17));	
				mvprintw(17,33,"Instructions");
				attron(COLOR_PAIR(2));		
				refresh();
				Sound5.Play();
				usleep(200000);	
				Istruzioni();		
			}
			else if(scelta==3)	
			{
				attron(COLOR_PAIR(17));
				mvprintw(19,36,"Exit");
				attron(COLOR_PAIR(2));	
				refresh();
				Sound5.Play();
				usleep(200000);			
			}
			
		}				
	}			
	refresh();  
	endwin(); 
	return 0; 
}

