/*
 
Copyright 2011 Bernardo Cuteri bernardoc91@hotmail.it  
 
This file is part of "Ascii Space Invaders".
 
"Ascii Space Invaders" is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
 
"Ascii Space Invaders" is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with "Ascii Space Invaders".  If not, see
<http://www.gnu.org/licenses/>.
 
*/

#include "Monster.h"
#include <ncursesw/ncurses.h>
Monster::Monster(bool att,int Y,int X)
:Attivita(att),CoordY(Y),CoordX(X),HP(1),Tipo(1),InMovimento(-1)
{		
}

int Monster::NumeroDiMostriAttivi=0;

void Monster::drawMonster()
{
	switch(Tipo)
	{
		case 1:
			
			attron(COLOR_PAIR(4));
			mvprintw(CoordY,CoordX,"*");
			attron(COLOR_PAIR(2));
			break;
		case 2:
			if(HP==2)
			{
				
				attron(COLOR_PAIR(5));
				mvprintw(CoordY,CoordX,"#");
			}
			else
			{
			
				attron(COLOR_PAIR(4));
				mvprintw(CoordY,CoordX,"#");
			}
			attron(COLOR_PAIR(2));
			break;
		case 3:
			if(HP==3)
			{				
				
				attron(COLOR_PAIR(10));
				mvprintw(CoordY,CoordX,"@");
				
			}
			else if(HP==2)
			{
			
				attron(COLOR_PAIR(5));
				mvprintw(CoordY,CoordX,"@");
			}
			else
			{
			
				attron(COLOR_PAIR(4));
				mvprintw(CoordY,CoordX,"@");
			}
			attron(COLOR_PAIR(2));
			break;
	}
	
}
void Monster::GameOver(int colore)
{
	switch(Tipo)
	{
		case 1:
			
			attron(COLOR_PAIR(colore));
			mvprintw(CoordY,CoordX,"*");			
			break;
		case 2:			
			attron(COLOR_PAIR(colore));
			mvprintw(CoordY,CoordX,"#");			
			break;
		case 3:			
			attron(COLOR_PAIR(colore));
			mvprintw(CoordY,CoordX,"@");			
			break;
	}
}
void Monster::delMonster()
{	
	mvprintw(CoordY,CoordX," ");

}
int Monster::getTipo()
{
	return Tipo;
}
int Monster::getMovimento()
{
	return InMovimento;	
}
void Monster::setMovimento(int value)
{
	InMovimento=value;
}
void Monster::setTipo(int tp)
{
	if(tp>0 && tp<4)
		Tipo=tp;
	else
		Tipo=1;
}


void Monster::disattivazione()
{
	Attivita=false;
	setMovimento(-1);
	delMonster();
	NumeroDiMostriAttivi--;
}
bool Monster::getAttivita()
{
	return Attivita;
}
void Monster::attivazione(int y,int x,int tp)
{
	CoordY=y;
	CoordX=x;
	Tipo=tp;
	switch(Tipo)
	{
		case 1:
			HP=1;
			break;
		case 2:
			HP=2;
			break;
		case 3:
			HP=3;
			break;
	}
	Attivita=true;
	NumeroDiMostriAttivi++;
}
int Monster::getHP()
{
	return HP;
}
bool Monster::danno(int value)
{
	if(HP-value>0)
	{
		HP-=value;		
		return false;
	}	
	
	disattivazione();
	return true;
}
int Monster::getY()
{
	return CoordY;
}
int Monster::getX()
{
	return CoordX;
}
void Monster::setCoordX(int value)
{
	CoordX=value;
}
void Monster::setCoordY(int value)
{
	CoordY=value;
}



