/*
 
Copyright 2011 Bernardo Cuteri bernardoc91@hotmail.it  
 
This file is part of "Ascii Space Invaders".
 
"Ascii Space Invaders" is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
 
"Ascii Space Invaders" is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with "Ascii Space Invaders".  If not, see
<http://www.gnu.org/licenses/>.
 
*/

#include "Navicella.h"
#include <ncurses.h>
#include <string>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <SFML/Audio.hpp>
using namespace std;



Navicella::Navicella()
: HP(3),Life(3),CoordX(40),RedPower(0),BluePower(0),Freeze(false),DoubleDrop(1)
{}
void Navicella::operator--(int)
{
	CoordX--;
}
void Navicella::operator++(int)
{
	CoordX++;
}
void Navicella::reset()
{
	HP=3;
	Life=3;
	CoordX=40;
	RedPower=0;
	BluePower=0;
	Freeze=false;
}
int Navicella::getX()
{
	return CoordX;
}
void Navicella::drawNav(int y,int colpita)
{
	
	char alaSX[2]={'<','\0'};
	char alaDX[2]={'>','\0'};
	char Punta[2]={'^','\0'};
	char Corpo[2]={'|','\0'};	
	//char Corpo[3]={0xd2,0x93,'\0'};
	
	attron(COLOR_PAIR(5));
	if(colpita==1 || colpita==2 || colpita==3)
	{	
		attron(COLOR_PAIR(7));
	}
	else if(colpita==4 || colpita==5 || colpita==6 || colpita==7 || colpita==8 || colpita==9)
	{		
		attron(COLOR_PAIR(6));
	}
	mvprintw(y,CoordX,Corpo);
	mvprintw(y,CoordX+1,alaDX);
	mvprintw(y,CoordX-1,alaSX);
	mvprintw(y-1,CoordX,Punta);
	if(RedPower==1)
	{	
		
		attron(COLOR_PAIR(7));
		mvprintw(y-1,CoordX,Punta);
	}	
	else if(RedPower==2)
	{			
		attron(COLOR_PAIR(10));
		mvprintw(y-1,CoordX,Punta);
	}
	else if(RedPower==3)
	{			
		attron(COLOR_PAIR(6));
		mvprintw(y-1,CoordX,Punta);
	}
	else if(BluePower==1)
	{	
	
		attron(COLOR_PAIR(7));
		mvprintw(y,CoordX+1,alaDX);
		mvprintw(y,CoordX-1,alaSX);
	}	
	else if(BluePower==2)
	{			
		attron(COLOR_PAIR(10));
		mvprintw(y,CoordX+1,alaDX);
		mvprintw(y,CoordX-1,alaSX);
	}
	else if(BluePower==3)
	{			
		attron(COLOR_PAIR(6));
		mvprintw(y,CoordX+1,alaDX);
		mvprintw(y,CoordX-1,alaSX);
	}
	init_pair(2,COLOR_BLACK,COLOR_WHITE);
	attron(COLOR_PAIR(2));
}
void Navicella::delNav(int y)
{	
	mvprintw(y,CoordX," ");
	mvprintw(y,CoordX+1," ");
	mvprintw(y,CoordX-1," ");
	mvprintw(y-1,CoordX," ");
}
bool Navicella::moveHP(int Value,bool & GameOver)
{
	if(HP+Value>=3)
	{
		HP=3;
		attron(COLOR_PAIR(17));
		for(int i=0;i<HP*4;i+=4)
		{
			mvprintw(20,2+i," ");
			mvprintw(20,3+i," ");
			mvprintw(20,4+i," ");		
		}
		attron(COLOR_PAIR(2));
	}
	else if(HP+Value<1)
	{
		Life--;
		if(Life==-1)
		{
			GameOver=true;
			return false;
		}				
		HP=3;		
		attron(COLOR_PAIR(17));
		for(int i=0;i<HP*4;i+=4)
		{
			mvprintw(20,2+i," ");
			mvprintw(20,3+i," ");
			mvprintw(20,4+i," ");		
		}
			
		attron(COLOR_PAIR(2));
		for(int i=0;i<(Life+1)*3;i+=3)
		{
			mvprintw(22,2+i," ");
			mvprintw(22,3+i," ");		
		}
		attron(COLOR_PAIR(15));
		for(int i=0;i<Life*3;i+=3)
		{
			mvprintw(22,2+i," ");
			mvprintw(22,3+i," ");		
		}
		attron(COLOR_PAIR(2));	
		if(RedPower)
			closeRedPower();	
		if(BluePower)
			closeBluePower();
		return true;	
	}		
	else
	{
				
		HP+=Value;		
		attron(COLOR_PAIR(2));	
		for(int i=0;i<12;i+=4)
		{
			mvprintw(20,2+i," ");
			mvprintw(20,3+i," ");
			mvprintw(20,4+i," ");		
		}
		attron(COLOR_PAIR(17));
		for(int i=0;i<HP*4;i+=4)
		{
			mvprintw(20,2+i," ");
			mvprintw(20,3+i," ");
			mvprintw(20,4+i," ");		
		}	
						
		attron(COLOR_PAIR(2));
	}
	return false;
}
void Navicella::UpVita()
{
	if(Life<5)
		Life++;	
	attron(COLOR_PAIR(15));
	for(int i=0;i<Life*3;i+=3)
	{
		mvprintw(22,2+i," ");
		mvprintw(22,3+i," ");	
	}
}

int Navicella::getRedPower()
{
	return RedPower;
}

void Navicella::riseRedPower()
{
	if(RedPower<3)
		RedPower++;
	if(BluePower)
		BluePower=0;	
	attron(COLOR_PAIR(5));
	mvprintw(17,65,"RED POWER!");
	attron(COLOR_PAIR(15));
	for(int i=0;i<RedPower*4;i+=4)
	{
		mvprintw(18,65+i," ");
		mvprintw(18,66+i," ");
		mvprintw(18,67+i," ");
	}
	attron(COLOR_PAIR(2));
	for(int i=0;i<12;i+=4)
	{
		mvprintw(16,65+i," ");
		mvprintw(16,66+i," ");
		mvprintw(16,67+i," ");
	}
	mvprintw(15,65,"           ");
	delNav(22);
	drawNav(22);
}
void Navicella::closeRedPower()
{
	RedPower=0;	
	mvprintw(17,65,"          ");
	for(int i=0;i<12;i+=4)   // 9=maxRedPower*3
	{
		mvprintw(18,65+i," ");
		mvprintw(18,66+i," ");
		mvprintw(18,67+i," ");
	}
	delNav(22);
	drawNav(22);
}
int Navicella::getBluePower()
{
	return BluePower;
}

void Navicella::riseBluePower()
{
	if(BluePower<3)
		BluePower++;
	if(RedPower)
		RedPower=0;	
	attron(COLOR_PAIR(10));
	mvprintw(15,65,"MULTI-SHOT!");
	attron(COLOR_PAIR(16));
	for(int i=0;i<BluePower*4;i+=4)
	{
		mvprintw(16,65+i," ");
		mvprintw(16,66+i," ");
		mvprintw(16,67+i," ");		
	}
	attron(COLOR_PAIR(2));
	mvprintw(17,65,"          ");
	for(int i=0;i<12;i+=4)   // 12=maxRedPower*3
	{
		mvprintw(18,65+i," ");
		mvprintw(18,66+i," ");
		mvprintw(18,67+i," ");
	}
	delNav(22);
	drawNav(22);
}
void Navicella::closeBluePower()
{
	BluePower=0;
	attron(COLOR_PAIR(2));	
	for(int i=0;i<12;i+=4)
	{
		mvprintw(16,65+i," ");
		mvprintw(16,66+i," ");
		mvprintw(16,67+i," ");
	}
	mvprintw(15,65,"           ");
	delNav(22);
	drawNav(22);
}
void Navicella::setFreeze(int val)
{
	Freeze=val;  //numero di frame col Freeze
	if(Freeze)
	{
		attron(COLOR_PAIR(3));
		mvprintw(20,65,"FREEZE!");
		
	}
	else		
		mvprintw(20,65,"       ");
	attron(COLOR_PAIR(2));
	
}
int Navicella::getFreeze()
{
	return Freeze;
}
void Navicella::setDoubleDrop(int value)
{
	DoubleDrop=value;
	if(DoubleDrop==2)
	{
		attron(COLOR_PAIR(12));
		mvprintw(21,65,"DOUBLE DROP!");
		
	}
	else		
		mvprintw(21,65,"            ");
	attron(COLOR_PAIR(2));
}
int Navicella::getDoubleDrop()
{
	return DoubleDrop;
}

